//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%420A5E2E03D7.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%420A5E2E03D7.cm

//## begin module%420A5E2E03D7.cp preserve=no
//## end module%420A5E2E03D7.cp

//## Module: PlotMcmc%420A5E2E03D7; Package body
//## Subsystem: XSPlot::Commands%3DA1AFD101BF
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Commands/PlotMcmc.cxx

//## begin module%420A5E2E03D7.additionalIncludes preserve=no
//## end module%420A5E2E03D7.additionalIncludes

//## begin module%420A5E2E03D7.includes preserve=yes
#include <XSPlot/Plot/PlotGroupCreatorClasses.h>
#include <XSPlot/Plot/PlotGroup.h>
#include <XSPlot/Plot/PlotSettings.h>
#include <XSPlot/Plot/PlotStyle.h>
#include <XSPlot/Plot/PlotTypes.h>

#include <XSFit/MCMC/Chain.h>
#include <XSFit/MCMC/ChainManager.h>
#include <XSModel/Model/Model.h>
#include <XSUtil/Error/Error.h>
#include <XSUtil/Parse/XSparse.h>
#include <algorithm>
//## end module%420A5E2E03D7.includes

// PlotMcmc
#include <XSPlot/Commands/PlotMcmc.h>
//## begin module%420A5E2E03D7.declarations preserve=no
//## end module%420A5E2E03D7.declarations

//## begin module%420A5E2E03D7.additionalDeclarations preserve=yes
//## end module%420A5E2E03D7.additionalDeclarations


// Class PlotMcmc 

PlotMcmc::PlotMcmc()
  //## begin PlotMcmc::PlotMcmc%420A5E7601B7_const.hasinit preserve=no
  //## end PlotMcmc::PlotMcmc%420A5E7601B7_const.hasinit
  //## begin PlotMcmc::PlotMcmc%420A5E7601B7_const.initialization preserve=yes
  : PlotCommand("chain", new CreateChainPlotGroups()),
    m_parNames(),
    m_xUsesRowNum(false)
  //## end PlotMcmc::PlotMcmc%420A5E7601B7_const.initialization
{
  //## begin PlotMcmc::PlotMcmc%420A5E7601B7_const.body preserve=yes
   doesTakeParameters(true);
   isDataRequired(false);
   isActiveModelRequired(false);
   isDivisibleByArea(false);
   addCompLevel(0);
   isBackgroundApplicable(false);
   
   PlotAttributes styles;
   styles.symbolStyle = PlotStyle::CIRCLE;
   styles.lineStyle = PlotStyle::NONE;
   setStyleMap(PlotStyle::DATA, styles);
  //## end PlotMcmc::PlotMcmc%420A5E7601B7_const.body
}


PlotMcmc::~PlotMcmc()
{
  //## begin PlotMcmc::~PlotMcmc%420A5E7601B7_dest.body preserve=yes
  //## end PlotMcmc::~PlotMcmc%420A5E7601B7_dest.body
}



//## Other Operations (implementation)
void PlotMcmc::setRanges (std::vector<PlotGroup*>& plotGroups, const PlotSettings& settings)
{
  //## begin PlotMcmc::setRanges%4B4650BD00D0.body preserve=yes
   // Only one plot group will exist for this command.
   // Can't assume xAxis data is ordered.
   const PlotGroup* chainGroup = plotGroups[0];
   
   PlotRange& rangeVals = rangeSettings();
   std::vector<Real>::const_iterator 
       beg_xdata = chainGroup->xAxis.data.begin(),
       end_xdata = chainGroup->xAxis.data.end();

   rangeVals.ranges.x1 = *std::min_element(beg_xdata, end_xdata);
   rangeVals.ranges.x2 = *std::max_element(beg_xdata, end_xdata);

   Real fraction = (rangeVals.ranges.x2 - rangeVals.ranges.x1) / 32.0;

   rangeVals.ranges.x1 -= fraction;
   rangeVals.ranges.x2 += fraction;

   std::vector<Real>::const_iterator 
       beg_ydata = chainGroup->yData.data.begin(),
       end_ydata = chainGroup->yData.data.end();

   rangeVals.ranges.y1 = *std::min_element(beg_ydata, end_ydata);
   rangeVals.ranges.y2 = *std::max_element(beg_ydata, end_ydata);

   fraction = (rangeVals.ranges.y2 - rangeVals.ranges.y1) / 32.0;

   rangeVals.ranges.y1 -= fraction;
   rangeVals.ranges.y2 += fraction;
   
   rangeVals.xScaleType = PlotStyle::LINEAR;
   rangeVals.yScaleType = PlotStyle::LINEAR;
   rangeVals.useRangeFlags = PlotStyle::XMIN + PlotStyle::XMAX +
                              PlotStyle::YMIN + PlotStyle::YMAX;
  //## end PlotMcmc::setRanges%4B4650BD00D0.body
}

void PlotMcmc::makeLabels (const PlotSettings& settings, StandardLabels& labels) const
{
  //## begin PlotMcmc::makeLabels%4B4650D00236.body preserve=yes
   string label = settings.lookupLabelName("t:chain");
   label += " MCMC";
   labels.title = label;
   
   // May need this for fit statistic label.  We could use
   // any of the chains.
   const Chain* firstChain = 
             ChainManager::Instance()->chains().begin()->second;
             
   if (m_xUsesRowNum)
      labels.x = settings.lookupLabelName("x:chain:row");
   else if (m_parNames.first.length())
   {
      // X-axis is a parameter
      labels.x = settings.lookupLabelName("x:chain:parameter");
      labels.x += " " + m_parNames.first;
   }
   else
   {
      // X-axis is a fit statistic, borrow contour plot's label.
      labels.x = settings.lookupLabelName("y:contour:statistic");
      labels.x += " " + firstChain->statistic();
   }
   
   if (m_parNames.second.length())
   {
      labels.y = settings.lookupLabelName("x:chain:parameter");
      labels.y += " " + m_parNames.second;
   }
   else
   {
      labels.y = settings.lookupLabelName("y:contour:statistic");
      labels.y += " " + firstChain->statistic();
   }
  //## end PlotMcmc::makeLabels%4B4650D00236.body
}

void PlotMcmc::processAdditionalParams (const StringArray& args, const IntegerArray& argIndices)
{
  //## begin PlotMcmc::processAdditionalParams%4B4650D60154.body preserve=yes
   ChainManager* chainManager = ChainManager::Instance();
   if (!chainManager->chains().size())
      throw YellowAlert("No chains are currently loaded.\n");
   
   const size_t nPars = args.size();
   if (nPars < 1)
      throw YellowAlert("Plot chain requires 1 (y) or 2 (x,y) parameters.\n");

   string xModelName; 
   string yModelName;
   size_t xParam = string::npos;
   size_t yParam = string::npos;
   if (nPars == 1)
   {
      m_xUsesRowNum = true;
      XSparse::stringIntPair(args[0], yModelName, yParam);
      if (yParam == string::npos)
         throw YellowAlert("Invalid y parameter number in chain plot.\n");
      if (!yModelName.length())
         yModelName = Model::DEFAULT();
   }
   else
   {
      m_xUsesRowNum = false;
      XSparse::stringIntPair(args[0], xModelName, xParam);
      if (xParam == string::npos)
         throw YellowAlert("Invalid x parameter number in chain plot.\n");
      if (!xModelName.length())
         xModelName = Model::DEFAULT();
      XSparse::stringIntPair(args[1], yModelName, yParam);
      if (yParam == string::npos)
         throw YellowAlert("Invalid y parameter number in chain plot.\n");
      if (!yModelName.length())
         yModelName = Model::DEFAULT();
   }
   // These are initialized to the last column in the chain file, which
   // is the fit statistic. They'll remain that way if the user enters
   // 0 for the param number.  If only 1 param number is entered, xColNum
   // will be set to 0 to let CreateChainPlotGroups know to use row numbers.  
   // (Column numbers are 1-based.)
   size_t xColNum = chainManager->width();
   size_t yColNum = chainManager->width();
   // Assume all chains have same parameters as the first chain.
   const Chain* firstChain = chainManager->chains().begin()->second;
   std::vector<size_t> loc;
   std::vector<Chain::ParamID> testPar(1);
   m_parNames.first = m_parNames.second = string("");
   
   if (m_xUsesRowNum)
      xColNum = 0;
   else if (xParam > 0)
   {
      testPar[0].modName = xModelName;
      testPar[0].index = xParam;
      firstChain->findParsInChain(testPar, loc);
      if (!loc.size())
         throw YellowAlert("Cannot locate specified x parameter in chain file.\n");
      xColNum = loc[0] + 1;
      m_parNames.first = testPar[0].parName;
   }
   
   if (yParam > 0)
   {
      testPar[0].modName = yModelName;
      testPar[0].index = yParam;
      firstChain->findParsInChain(testPar, loc);
      if (!loc.size())
         throw YellowAlert("Cannot locate specified y parameter in chain file.\n");
      yColNum = loc[0] + 1;
      m_parNames.second = testPar[0].parName;
   }
      
   CreateChainPlotGroups* groupCreator = 
        dynamic_cast<CreateChainPlotGroups*>(plotGroupStrategy());
   groupCreator->xColNum(xColNum);
   groupCreator->yColNum(yColNum);   
  //## end PlotMcmc::processAdditionalParams%4B4650D60154.body
}

// Additional Declarations
  //## begin PlotMcmc%420A5E7601B7.declarations preserve=yes
  //## end PlotMcmc%420A5E7601B7.declarations

//## begin module%420A5E2E03D7.epilog preserve=yes
//## end module%420A5E2E03D7.epilog
